//+------------------------------------------------------------------+
//|        Modified Money Management   Based on    Scalp_Net         |
//|          WilliamsTradeEA_V1.mq4                                  |
//|                                       "http://www.forex-tsd.com" |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Brooky."
#property link      "http://www.NoLinkYet.com"

extern int MagicNumber = 9898;
extern bool EachTickMode = False;
extern double Lots = 0.01;
extern int Slippage = 3;
extern bool StopLossMode = True;
extern int StopLoss = 60;
extern bool TakeProfitMode = True;
extern int TakeProfit = 260;
extern bool TrailingStopMode = True;
extern int TrailingStop = 95;
extern double MaximumRisk       =0.15;
extern double DecreaseFactor    =3;
extern int MaxOrders = 1;
extern bool UseHourTrade = False;
extern int FromHourTrade = 0;
extern int ToHourTrade = 23;
//externs for iCustom 

extern int       wperiod=500;
extern int       short_level=-58;
extern int       long_level=-40;
extern int       valid_bars_back=30;
//

#define SIGNAL_NONE 0
#define SIGNAL_BUY   1
#define SIGNAL_SELL  2
#define SIGNAL_CLOSEBUY 3
#define SIGNAL_CLOSESELL 4
int TimeBar;
int BarCount;
int Current;
bool TickCheck = True;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
if (UseHourTrade)
{
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade))
       {
         Comment("Time for trade has not come else!");
       return(0);
       }  
     
   }
   int Order = SIGNAL_NONE;
   int Total, Ticket;
   double StopLossLevel, TakeProfitLevel;

   int digit  = MarketInfo(Symbol(),MODE_DIGITS);

   if (EachTickMode && Bars != BarCount) EachTickMode = False;
   Total = OrdersTotal();
   Order = SIGNAL_NONE;

   if (Hour()>=FromHourTrade && Hour()<=ToHourTrade)
   {   
   //+------------------------------------------------------------------+
   //| Signal Begin                                                     |
   //+------------------------------------------------------------------+
int upsig=0;
int dnsig = 0;
      
double Sig1_1 = 111;
double Sig1_2 = 1;   
double Sig2_1 = 222;
double Sig2_2 = 2;
////////////////////////////////////////
 
double array = iWPR(NULL,0,wperiod,0);
double arrayb4 = iWPR(NULL,0,wperiod,1);


if(iWPR(NULL,0,wperiod,0)<iWPR(NULL,0,wperiod,1) && iWPR(NULL,0,wperiod,0)<short_level && iWPR(NULL,0,wperiod,1)>=short_level && iWPR(NULL,0,wperiod,valid_bars_back)<short_level+20)dnsig=1;
if(iWPR(NULL,0,wperiod,0)>iWPR(NULL,0,wperiod,1) && iWPR(NULL,0,wperiod,0)>long_level && iWPR(NULL,0,wperiod,1)<=long_level && iWPR(NULL,0,wperiod,valid_bars_back)<long_level-20)upsig=1;



   
if( upsig>0)  Sig1_1=1;
if( dnsig>0)  Sig2_1=2;
   //+------------------------------------------------------------------+
   //| Signal END                                                       |
   //+------------------------------------------------------------------+     
      
      if (
      		(Sig1_1 == Sig1_2) 
      	) 
      {
      	Order = SIGNAL_BUY;
      }
      
      if (
      		(Sig2_1 ==Sig2_2 )

      	) 
      {
      	Order = SIGNAL_SELL;
      }
   //+------------------------------------------------------------------+
   //| Signal End                                                       |
   //+------------------------------------------------------------------+
   }
   
   //Buy
   if (Order == SIGNAL_BUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }

         StopLossLevel = Ask - StopLoss * Point;
         TakeProfitLevel = Ask + TakeProfit * Point;
         /*Instant execution broker
         Ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), 
                            NormalizeDouble(Ask,digit), 
                            Slippage, 
                            NormalizeDouble(StopLossLevel,digit),  
                            NormalizeDouble(TakeProfitLevel,digit),  
                            "Buy(#" + MagicNumber + ")", MagicNumber, 0, DodgerBlue);
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("BUY order opened : ", OrderOpenPrice()); else Print("Error opening BUY order : ", GetLastError());
         }
         */
                  //ECN Buy start

Ticket = OrderSend(Symbol(),OP_BUY, LotsOptimized(),NormalizeDouble(Ask,digit),0,0,0, 
"WilliamsTrade Buy(#" + MagicNumber + ")",MagicNumber,0, DodgerBlue);
if(Ticket>0)
{
OrderSelect(Ticket,SELECT_BY_TICKET);
OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,DodgerBlue);
}
else
{
Print("ECN Buy OrderSend failed with error #",GetLastError());
}
         
         //ECN End Start
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Sell
   if (Order == SIGNAL_SELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
      if(ScanTrades() < MaxOrders) {
         //Check free margin
         if (AccountFreeMargin() < (1000 * Lots)) {
            Print("We have no money. Free Margin = ", AccountFreeMargin());
            return(0);
         }
         StopLossLevel = Bid + StopLoss * Point;
         TakeProfitLevel = Bid - TakeProfit * Point;
        /*//Instant Execution Broker
         Ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), 
                            NormalizeDouble(Bid,digit), 
                            Slippage, 
                            NormalizeDouble(StopLossLevel,digit),  
                            NormalizeDouble(TakeProfitLevel,digit),  
                            "Sell(#" + MagicNumber + ")", MagicNumber, 0, DeepPink);
         
         
         
         if(Ticket > 0) {
            if (OrderSelect(Ticket, SELECT_BY_TICKET, MODE_TRADES)) Print("SELL order opened : ", OrderOpenPrice()); else Print("Error opening SELL order : ", GetLastError());
         }
         */
                 //ECN SELL
         Ticket = OrderSend(Symbol(),
OP_SELL, 
LotsOptimized(),
NormalizeDouble(Bid,digit), 
0, 
0,  
0,  
"WilliamsTrade Sell(#" + MagicNumber + ")",
MagicNumber,
0, 
DeepPink);
if(Ticket>0)
{
OrderSelect(Ticket,SELECT_BY_TICKET);
OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(StopLossLevel,digit),NormalizeDouble(TakeProfitLevel,digit),0,DodgerBlue);
}
else
{
Print("RDI_ADD ECN Sell OrderSend failed with error #",GetLastError());
}
         //ECN Sell Stop
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0);
      }
   }

   //Check position
   for (int i = 0; i < Total; i ++) {
      OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(OrderType() <= OP_SELL &&  OrderSymbol() == Symbol()) {
         if(OrderType() == OP_BUY && OrderMagicNumber()==MagicNumber ) {
            //Close
            if (Order == SIGNAL_CLOSEBUY && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) {
               OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, MediumSeaGreen);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
            }
            //Trailing stop
            if(TrailingStopMode && TrailingStop > 0) {                 
               if(Bid - OrderOpenPrice() > Point * TrailingStop) {
                  if(OrderStopLoss() < Bid - Point * TrailingStop) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Bid - Point * TrailingStop, OrderTakeProfit(), 0, MediumSeaGreen);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
         } else {
            if(OrderType()==OP_SELL && OrderMagicNumber()==MagicNumber)
            {
           
            //Close
            if (Order == SIGNAL_CLOSESELL && ((EachTickMode && !TickCheck) || (!EachTickMode && (Bars != BarCount)))) 
               {
               OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, DarkOrange);
               if (EachTickMode) TickCheck = True;
               if (!EachTickMode) BarCount = Bars;
               return(0);
               }
            //Trailing stop
            if (TrailingStopMode && TrailingStop > 0) 
               {                 
               if((OrderOpenPrice() - Ask) > (Point * TrailingStop)) {
                  if((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0)) {
                     OrderModify(OrderTicket(), OrderOpenPrice(), Ask + Point * TrailingStop, OrderTakeProfit(), 0, DarkOrange);
                     if (!EachTickMode) BarCount = Bars;
                     return(0);
                  }
               }
            }
         }}
      }
   }

   if (!EachTickMode) BarCount = Bars;

   return(0);
}

int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(int cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()<=OP_SELLSTOP && OrderMagicNumber() == MagicNumber) 
   numords++;
   }
   return(numords);
}  

//bool ExistPositions() {
//	for (int i=0; i<OrdersTotal(); i++) {
//		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
//			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber) {
//				return(True);
//			}
//		} 
//	} 
//	return(false);
//}

double LotsOptimized()
  {
   double lot=Lots;
   int    orders=HistoryTotal();     // history orders total
   int    losses=0;                  // number of losses orders without a break
//---- select lot size
   if(MaximumRisk>0)lot=NormalizeDouble(Lots*AccountFreeMargin()*MaximumRisk/1000.0,1);
//---- calcuulate number of losses orders without a break
   if(DecreaseFactor>0)
     {
      for(int i=orders-1;i>=0;i--)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY)==false) { Print("Error in history!"); break; }
         if(OrderSymbol()!=Symbol() || OrderType()>OP_SELL) continue;
         //----
         if(OrderProfit()>0) break;
         if(OrderProfit()<0) losses++;
        }
      if(losses>1) lot=NormalizeDouble(lot-lot*losses/DecreaseFactor,1);
     }
//---- return lot size
   if(lot<0.1) lot=0.1;
   return(lot);
   }


//+------------------------------------------------------------------+